'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcUtil = require('rc-util');

var MenuItem = (function (_React$Component) {
  _inherits(MenuItem, _React$Component);

  function MenuItem(props) {
    var _this = this;

    _classCallCheck(this, MenuItem);

    _get(Object.getPrototypeOf(MenuItem.prototype), 'constructor', this).call(this, props);
    ['onKeyDown', 'onMouseLeave', 'onMouseEnter', 'onClick'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });
  }

  _createClass(MenuItem, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var props = this.props;
      if (props.onDestroy) {
        props.onDestroy(props.eventKey);
      }
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      var keyCode = e.keyCode;
      if (keyCode === _rcUtil.KeyCode.ENTER) {
        this.onClick(e);
        return true;
      }
    }
  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave() {
      var _this2 = this;

      this.props.parent.leaveTimer = setTimeout(function () {
        _this2.props.parent.leaveTimer = null;
        _this2.props.onItemHover({
          key: _this2.props.eventKey,
          item: _this2,
          hover: false,
          trigger: 'mouseleave'
        });
      }, 100);
    }
  }, {
    key: 'onMouseEnter',
    value: function onMouseEnter() {
      if (this.props.parent.leaveTimer) {
        clearTimeout(this.props.parent.leaveTimer);
        this.props.parent.leaveTimer = null;
      }
      var props = this.props;
      props.onItemHover({
        key: this.props.eventKey,
        item: this,
        hover: true,
        trigger: 'mouseenter'
      });
    }
  }, {
    key: 'onClick',
    value: function onClick(e) {
      var props = this.props;
      var eventKey = props.eventKey;
      var info = {
        key: eventKey,
        item: this,
        domEvent: e
      };
      props.onClick(info);
      if (props.multiple) {
        if (props.selected) {
          props.onDeselect(info);
        } else {
          props.onSelect(info);
        }
      } else if (!props.selected) {
        props.onSelect(info);
      }
    }
  }, {
    key: 'getPrefixCls',
    value: function getPrefixCls() {
      return this.props.rootPrefixCls + '-item';
    }
  }, {
    key: 'getActiveClassName',
    value: function getActiveClassName() {
      return this.getPrefixCls() + '-active';
    }
  }, {
    key: 'getSelectedClassName',
    value: function getSelectedClassName() {
      return this.getPrefixCls() + '-selected';
    }
  }, {
    key: 'getDisabledClassName',
    value: function getDisabledClassName() {
      return this.getPrefixCls() + '-disabled';
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var classes = {};
      classes[this.getActiveClassName()] = !props.disabled && props.active;
      classes[this.getSelectedClassName()] = props.selected;
      classes[this.getDisabledClassName()] = props.disabled;
      classes[this.getPrefixCls()] = true;
      var attrs = {
        title: props.title,
        className: (0, _rcUtil.joinClasses)(props.className, (0, _rcUtil.classSet)(classes)),
        role: 'menuitem',
        'aria-selected': props.selected,
        'aria-disabled': props.disabled
      };
      var mouseEvent = {};
      if (!props.disabled) {
        mouseEvent = {
          onClick: this.onClick,
          onMouseLeave: this.onMouseLeave,
          onMouseEnter: this.onMouseEnter
        };
      }
      var style = {};
      if (props.mode === 'inline') {
        style.paddingLeft = props.inlineIndent * props.level;
      }
      return _react2['default'].createElement(
        'li',
        _extends({ style: style
        }, attrs, mouseEvent),
        props.children
      );
    }
  }]);

  return MenuItem;
})(_react2['default'].Component);

MenuItem.propTypes = {
  rootPrefixCls: _react2['default'].PropTypes.string,
  eventKey: _react2['default'].PropTypes.string,
  active: _react2['default'].PropTypes.bool,
  selected: _react2['default'].PropTypes.bool,
  disabled: _react2['default'].PropTypes.bool,
  title: _react2['default'].PropTypes.string,
  onSelect: _react2['default'].PropTypes.func,
  onClick: _react2['default'].PropTypes.func,
  onDeselect: _react2['default'].PropTypes.func,
  parent: _react2['default'].PropTypes.object,
  onItemHover: _react2['default'].PropTypes.func,
  onDestroy: _react2['default'].PropTypes.func
};

MenuItem.defaultProps = {
  onSelect: function onSelect() {},
  onMouseEnter: function onMouseEnter() {}
};

exports['default'] = MenuItem;
module.exports = exports['default'];